//
//  PickerViewController.swift
//  DigitalOutput
//
//  Created by Phidgets on 2018-01-24.
//  Copyright © 2018 Phidgets. All rights reserved.
//

import UIKit
import Phidget22Swift

class PickerViewController: UIViewController, UIPickerViewDelegate, UIPickerViewDataSource {
    
    @IBOutlet var pickerTitle: UILabel!
    @IBOutlet var pickerBox: UIView!
    @IBOutlet var pickerView: UIPickerView!
    var pickerArray = [String]()
    var titleName = String()
    var ch = DigitalOutput()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        pickerBox.layer.cornerRadius = 5
        pickerBox.layer.masksToBounds = true
        pickerTitle.text = titleName
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return pickerArray.count
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return pickerArray[row]
    }
    
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        var text = (view as? UILabel)
        if text == nil{
            text = UILabel.init()
        }
        text?.font = UIFont.systemFont(ofSize: 25, weight: UIFont.Weight.light)
        text?.textAlignment = .center
        text?.adjustsFontSizeToFitWidth = true
        text?.text = self.pickerView(pickerView, titleForRow: row, forComponent: component)
        
        return text!
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        let resultString:String = (pickerArray[row])
        do{
            if resultString == "1.7 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_1_7)
            }
            else if resultString == "2.75 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_2_75)
            }
            else if resultString == "3.2 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_3_2)
            }
            else if resultString == "3.9 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_3_9)
            }
            else if resultString == "4.0 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_4_0)
            }
            else if resultString == "4.8 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_4_8)
            }
            else if resultString == "5.0 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_5_0)
            }
            else if resultString == "5.6 Volts"{
                try ch.setLEDForwardVoltage(LEDForwardVoltage.volts_5_6)
            }
        } catch let err as PhidgetError {
            outputErrorMessage(errorTitle: "Error Code: \(err.errorCode)", errorMessage: err.description)
        } catch {
            print (error)
        }
        
    }
    
    @IBAction func done(_ sender: AnyObject) {
            self.performSegue(withIdentifier: "digitalOutputDoneSegue", sender: self)
    }
    
    var timeStamp:TimeInterval = 0
    var lastTimeStamp:TimeInterval = 0
    func outputErrorMessage(errorTitle:String, errorMessage:String){
        timeStamp = NSDate.timeIntervalSinceReferenceDate
        //Add a delay for error events so the user does not get bombarded by error events
        if(timeStamp - lastTimeStamp > 5){
            let alert = UIAlertController(title: errorTitle, message: errorMessage, preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: "OK", style: .default, handler: {action -> Void in
            }))
            self.present(alert, animated: true, completion: nil)
            lastTimeStamp = timeStamp
        }
    }
    
}

